"""
    Constants defined in the editor widget javascript.
    These are all allowed tools and tabs which the widget accepts.
"""

class TABS_IDS:
    """
        Possible tabs to use in the editor widget.
    """
    FINETUNE:   str = 'Finetune'
    FILTERS:    str = 'Filters'
    ADJUST:     str = 'Adjust'
    WATERMARK:  str = 'Watermark'
    ANNOTATE:   str = 'Annotate'
    RESIZE:     str = 'Resize'


class TOOLS_IDS:
  """
    Possible tools to use in the editor widget.
  """
  CROP:       str = 'Crop',
  ROTATE:     str = 'Rotate',
  FLIP_X:     str = 'Flip_X',
  FLIP_Y:     str = 'Flip_Y',
  BRIGHTNESS: str = 'Brightness',
  CONTRAST:   str = 'Contrast',
  HSV:        str = 'HueSaturationValue',
  WARMTH:     str = 'Warmth',
  BLUR:       str = 'Blur',
  THRESHOLD:  str = 'Threshold',
  POSTERIZE:  str = 'Posterize',
  PIXELATE:   str = 'Pixelate',
  NOISE:      str = 'Noise',
  FILTERS:    str = 'Filters',
  RECT:       str = 'Rect',
  ELLIPSE:    str = 'Ellipse',
  POLYGON:    str = 'Polygon',
  TEXT:       str = 'Text',
  LINE:       str = 'Line',
  IMAGE:      str = 'Image',
  ARROW:      str = 'Arrow',
  WATERMARK:  str = 'Watermark',
  PEN:        str = 'Pen',
  RESIZE:     str = 'Resize',
